/**
 * approve.js 0.0.4
 * A simple validation library that doesn't interfere.
 * Author: Charl Gottschalk
 * @license: MIT
 */
!function(e,t){e._approve=e.approve,"function"==typeof define&&define.amd?define(function(){return e.approve=t(e)}):"object"==typeof exports?module.exports=t(e):e.approve=t(e)}(this,function(e){var t={};return t.VERSION="0.0.4",t.tests={required:{validate:function(e){return!!e},message:"{title} is required",expects:!1},email:{regex:/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i,validate:function(e){return this.regex.test(e)},message:"{title} must be a valid email address",expects:!1},url:{regex:/^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/i,validate:function(e){return this.regex.test(e)},message:"{title} must be a valid web address",expects:!1},cc:{regex:/^(?:(4[0-9]{12}(?:[0-9]{3})?)|(5[1-5][0-9]{14})|(6(?:011|5[0-9]{2})[0-9]{12})|(3[47][0-9]{13})|(3(?:0[0-5]|[68][0-9])[0-9]{11})|((?:2131|1800|35[0-9]{3})[0-9]{11}))$/,validate:function(e){return this.regex.test(e)},message:"{title} must be a valid credit card number",expects:!1},alphaNumeric:{regex:/^[A-Za-z0-9]+$/i,validate:function(e){return this.regex.test(e)},message:"{title} may only contain [A-Za-z] and [0-9]",expects:!1},numeric:{regex:/^[0-9]+$/,validate:function(e){return this.regex.test(e)},message:"{title} may only contain [0-9]",expects:!1},alpha:{regex:/^[A-Za-z]+$/,validate:function(e){return this.regex.test(e)},message:"{title} may only contain [A-Za-z]",expects:!1},decimal:{regex:/^\s*(\+|-)?((\d+(\.\d+)?)|(\.\d+))\s*$/,validate:function(e){return this.regex.test(e)},message:"{title} must be a valid decimal",expects:!1},currency:{regex:/^\s*(\+|-)?((\d+(\.\d\d)?)|(\.\d\d))\s*$/,validate:function(e){return this.regex.test(e)},message:"{title} must be a valid currency value",expects:!1},ip:{regex:{ipv4:/^(?:(?:\d|[1-9]\d|1\d{2}|2[0-4]\d|25[0-5])\.){3}(?:\d|[1-9]\d|1\d{2}|2[0-4]\d|25[0-5])$/,ipv6:/^((?=.*::)(?!.*::.+::)(::)?([\dA-F]{1,4}:(:|\b)|){5}|([\dA-F]{1,4}:){6})((([\dA-F]{1,4}((?!\3)::|:\b|$))|(?!\2\3)){2}|(((2[0-4]|1\d|[1-9])?\d|25[0-5])\.?\b){4})$/i},validate:function(e){return this.regex.ipv4.test(e)||this.regex.ipv6.test(e)},message:"{title} must be a valid IP address",expects:!1},min:{validate:function(e,t){return"string"==typeof e&&e.length>=t.min},message:"{title} must be a minimum of {min} characters",expects:["min"]},max:{validate:function(e,t){return"string"==typeof e&&e.length<=t.max},message:"{title} must be a maximum of {max} characters",expects:["max"]},range:{validate:function(e,t){return"string"==typeof e&&e.length>=t.min&&e.length<=t.max},message:"{title} must be a minimum of {min} and a maximum of {max} characters",expects:["min","max"]},equal:{validate:function(e,t){var s=document.getElementById(t.field);return""+e==""+s.value},message:"{title} must be equal to {field}",expects:["field"]},format:{validate:function(e,t){return"[object RegExp]"===Object.prototype.toString.call(t.regex)?t.regex.test(e):(console.error("approve.tests.format(value, regex): regex is not a valid regular expression."),!1)},message:"{title} did not pass the [{regex}] test",expects:["regex"]}},t._format=function(e,t){return t="object"==typeof t?t:Array.prototype.slice.call(arguments,1),e.replace(/\{\{|\}\}|\{(\w+)\}/g,function(e,s){return"{{"==e?"{":"}}"==e?"}":t[s]})},t._formatMessages=function(e,t,s,r){for(var a=this._getFormat(t,s,r),i=e.length-1;i>=0;i--)e[i]=this._format(e[i],a).trim();return e},t._getFormat=function(e,t,s){var r={};if(Array.isArray(this.tests[e].expects))for(var a="",i=this.tests[e].expects.length-1;i>=0;i--)a=this.tests[e].expects[i],t[e].hasOwnProperty(a)&&(r[a]=t[e][a]),/^[A-Za-z0-9]+$/i.test(t[e])&&(r[a]=t[e]);return t.hasOwnProperty("title")?r.title=t.title:r.title=s,r},t._message=function(e,t,s){if(t[e].hasOwnProperty("message"))return t[e].message;var r=this.tests[e].message,a=this._getFormat(e,t,s);return this._format(r,a).trim()},t.value=function(e,t,s){"object"!=typeof t&&console.error("approve.value(value, rules): rules is not a valid object.");var r={approved:!0,errors:[],each:function(e){for(var t=e&&e.constructor&&e.call&&e.apply,s=this.errors.length-1;s>=0;s--)t&&e(this.errors[s])}};for(var a in t)if(t.hasOwnProperty(a)&&(s=s||"",this.tests.hasOwnProperty(a))){var i={};if(Array.isArray(this.tests[a].expects))for(var u=this.tests[a].expects.length-1;u>=0;u--){var n=this.tests[a].expects[u];t[a].hasOwnProperty(n)?i[n]=t[a][n]:i[n]=t[a]}t[a].hasOwnProperty("config")&&(i.config=t[a].config);var o=this.tests[a].validate(e,i);if("object"==typeof o){o.valid||(r.approved=!1,r.errors.push(this._message(a,t,s))),r.errors=r.errors.concat(this._formatMessages(o.errors,a,t,s));for(var m in o)o.hasOwnProperty(m)&&(r[m]=o[m])}else"boolean"!=typeof o?(r.approved=!1,r.errors.push(this._message(a,t,s))):o||(r.approved=!1,r.errors.push(this._message(a,t,s)))}return r},t.addTest=function(e,t){"object"!=typeof e&&console.error("approve.addTest(obj, name): obj is not a valid object.");try{this.tests.hasOwnProperty(t)||(this.tests[t]=e)}catch(s){console.error("approve.addTest(): "+s.message)}},t.noconflict=function(){return e.approve=e._approve,this},t});var strength={minimum:8,minimumBonus:10,messages:{0:"Very Weak",1:"Weak",2:"Better",3:"Almost",4:"Acceptable",5:"Strong",6:"Very Strong"},message:"{title} did not pass the strength test.",expects:["min","bonus"],errors:{isMinimum:"{title} must be at least {min} characters",hasLower:"{title} must have at least 1 lower case character",hasUpper:"{title} must have at least 1 upper case character",hasNumber:"{title} must have at least 1 number",hasSpecial:"{title} must have at least 1 special character"},score:function(e){var t={value:0,isMinimum:!1,hasLower:!1,hasUpper:!1,hasNumber:!1,hasSpecial:!1,isBonus:!1,strength:0};return e.length>this.minimum?(t.value++,t.isMinimum=!0):(t.value=1,t.isMinimum=!1),e.match(/[a-z]/)&&(t.isMinimum&&t.value++,t.hasLower=!0),e.match(/[A-Z]/)&&(t.isMinimum&&t.value++,t.hasUpper=!0),e.match(/\d+/)&&(t.isMinimum&&t.value++,t.hasNumber=!0),e.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/)&&(t.isMinimum&&t.value++,t.hasSpecial=!0),e.length>this.minimumBonus&&(t.value++,t.isBonus=!0),t.strength=Math.ceil(t.value/6*100),t},strength:function(e){var t={message:this.messages[0],minimum:this.minimum,minimumBonus:this.minimumBonus,score:{},valid:!1,errors:[]};return t.score=this.score(e),t.message=this.messages[t.score.value],t.score.isMinimum||t.errors.push(this.errors.isMinimum),t.score.hasLower||t.errors.push(this.errors.hasLower),t.score.hasUpper||t.errors.push(this.errors.hasUpper),t.score.hasSpecial||t.errors.push(this.errors.hasSpecial),t.score.hasNumber||t.errors.push(this.errors.hasNumber),t.score.value>4&&(t.valid=!0),t},validate:function(e,t){if(this.minimum=t.min||this.minimum,this.minimumBonus=t.bonus||this.minimumBonus,t.hasOwnProperty("config")&&t.config.hasOwnProperty("messages"))for(var s in t.config.messages)t.config.messages.hasOwnProperty(s)&&(this.errors[s]=t.config.messages[s]);return this.strength(e)}};approve.addTest(strength,"strength");
//# sourceMappingURL=approve.min.js.map
